this.afterModuleInit = function () {
  var self = this;
  var lang_def = APP.languageDefine();
  // 根据语言定义确定要查的title_i18n
  var cfg = self.config();
  var data_keys = self.config('view.data_keys');
  _.forEach(lang_def, function (v, k) {
    data_keys.push('attr_data.title_i18n.' + k);
    self.setUserData('attr_data.title_i18n.' + k + '.visible', 0);
  });
  _.set(cfg, 'view.data_keys', data_keys);
  self.setConfig(cfg);

  // 根据语言定义动态修改detail.ui.js
  var detail_ui = self.ui('detail');
  var title_i18n_actions = [];
  var title_i18n_widgets = [];
  var action_template_str = "{ \
      type: 'Action', \
      property: { text: '{0}', user_data: '{1}', checkable: true}, \
      callback: function(obj, checked, self) { \
        var lang = obj.getData('user_data'); \
        self.setUserData('{2}'+lang+'.visible', checked); \
        this.refreshState(); \
      } \
    }";
  var widget_template_str = "{ \
      name: '{0}', \
      type: 'LineEdit', \
      title: self.ttr('Title') + ' ({1})', \
      pack: { label: self.ttr('Title') + ' ({1})' }, \
      state: function(obj, self) { \
        var v = self.userData('{0}.visible'); \
        if (v) { \
          return 'show'; \
        } else { \
          return 'hide'; \
        } \
      }, \
      getter: function(obj) { \
        if (_.isEmpty(obj.text)) { \
          return null; \
        } \
        return obj.text; \
      } \
    }";
  _.forEach(lang_def, function (v, k) {
    title_i18n_actions.push(_.format(action_template_str, v, k, 'attr_data.title_i18n.'));
    title_i18n_widgets.push(_.format(widget_template_str, 'attr_data.title_i18n.' + k, v));
  });
  detail_ui = detail_ui.replace('/*{% TITLE_I18N_ACTIONS %}*/', title_i18n_actions.join(','))
    .replace('/*{% TITLE_I18N_WIDGETS %},*/', title_i18n_widgets.join(',') + ',');
  self.setUi('detail', detail_ui);

  // 根据语言定义动态修改option-list.ui.js
  var option_ui = self.ui('option-list');
  var option_i18n_actions = [];
  var option_i18n_widgets = [];
  _.forEach(lang_def, function (v, k) {
    option_i18n_actions.push(_.format(action_template_str, v, k, 'text_'));
    option_i18n_widgets.push(_.format(widget_template_str, 'text_' + k, v));
  });
  option_ui = option_ui.replace('/*{% TITLE_I18N_ACTIONS %}*/', option_i18n_actions.join(','))
    .replace('/*{% TITLE_I18N_WIDGETS %},*/', option_i18n_widgets.join(',') + ',');
  self.setUi('option-list', option_ui);
};

