var query = new TSqlQueryV2(T_SQLCNT_POOL.getSqlDatabase());
var self = this;
try {
    var selector = new TSqlSelectorV2;
    selector.setTable("pdm_attrname");
    selector.setField(["id", "name", "title", "storage_flag"]);
    selector.setWhere("del_flag = 0 OR del_flag IS NULL");
    var error = new TError;
    var data = this.runSqlQueryOnThreadSync('TOPSQLTHREAD_SELECT_ARRAYMAP', selector, error);
	if (error.isValid()) {
		throw error.text();
    }

    var flagTrueList = [];    //storage_flag = 1
    var flagFalseList = [];   //storage_flag = 0 or null
    _.forEach(data, function(item){
        var storage_flag = item["storage_flag"];
        if (storage_flag == 1) {
            flagTrueList.push(item);
        } else {
            flagFalseList.push(item);
        }
    });
    var dialog = new TTableChooserDialog(self);
    dialog.setTitle(self.ttr("Set primary attrname"));
    dialog.setButtons([self.ttr('Ok') + ':Ok:Ok:Primary', self.ttr('Cancel') + ':Cancel:Cancel:ERROR']);
    dialog.setIcon("pdm-setting.546998d");
    dialog.setRepetitionEnabled(false);
    dialog.setPrimaryKey('id');
    dialog.setSearchKeys(['name', 'title']);
    dialog.setHeaderItem(
        [
            {

            },
            {
                name: 'name',
                display: self.ttr('Attrname'),
                displayRole: '$name',
                resizeMode: 'Stretch',
                sorting_enabled: 1,
            },
            {
                name: 'title',
                display: self.ttr('Title'),
                displayRole: '$title',
                resizeMode: 'Stretch',
                sorting_enabled: 0
            }
        ]
    );
    dialog.setDataKeyList(['id', 'name', 'title', 'storage_flag']);
    dialog.loadAllData(flagFalseList);
    dialog.loadSelectedData(flagTrueList);

    var ret = dialog.run();
    if (_.isEmpty(ret)) {
        return;
    }

    var newFlagFalseList = dialog.tableView().allDataMap();
    var newFlagTrueList = dialog.selectedTableView().allDataMap();
    var flagTrueIds = [];
    var flagFalseIds = [];
    _.forEach(newFlagTrueList, function(item) {
        flagTrueIds.push(item['id']);
    });

    _.forEach(newFlagFalseList, function(item) {
        flagFalseIds.push(item['id']);
    });

    var updater = new TSqlUpdaterV2;
    updater.setTable('pdm_attrname');
    var updateTrueMap = {};
    updateTrueMap["storage_flag"] = 1;
    updater.setField(["storage_flag"]);
    updater.setWhere("id", flagTrueIds);
    updater.setData(updateTrueMap);
    query.updateRow(updater);
    var error = query.lastError();
    if (error.isValid()) {
        throw error;
    }

    var updateFalseMap = {};
    updateFalseMap["storage_flag"] = 0;
    updater.setField(["storage_flag"]);
    updater.setWhere("id", flagFalseIds);
    updater.setData(updateFalseMap);
    query.updateRow(updater);
    var error = query.lastError();
    if (error.isValid()) {
        throw error;
    }
    query.commit(); 	
} catch (e) {
    query.rollback();
    this.alertError(this.ttr('Error!'), e);
    print(e);
}

/*---ACTION---
ICON: "pdm-setting.#54698d"
LABEL: "Set Primary Attributes"
LABEL_ZHCN: "设置关键属性"
LABEL_ZHTW: "設置關鍵屬性"
ACCEL: ""
TOOLTIP: "Set Primary Attributes"
TOOLTIP_ZHCN: "设置关键属性"
TOOLTIP_ZHTW: "設置關鍵屬性"
CHECKED: ""
GROUP: ""
LABEL_EN: ""
LABEL_JP: ""
TOOLTIP_EN: ""
TOOLTIP_JP: ""
PERMISSION: "pdm-attr-name-edit"
STYLE: "button_style=both"
LANG: "JavaScript"
STATUS: "Release"
VERSION: "1"
STATEHOOK: ""
---ACTION---*/