function func(self) {
    return [
        {
            name: 'scrollarea',
            type: 'ScrollArea',
            property:
            {
                widget_resizable: true, frame_shape: 'NoFrame'
            },
            pack: {},
            child: [
                {
                    name: 'vlayout',
                    type: 'VBoxLayout',
                    property:
                    {
                        margin: 0, spacing: 10
                    },
                    pack: {},
                    child: [
                        {
                            name: 'fglayout',
                            type: 'FormGridLayout',
                            property:
                            {
                                label_alignment: 'AlignRight', margin: 20, vertical_spacing: 10, horizontal_spacing: 20
                            },
                            pack: {},
                            child: [
                                {
                                    name: 'id',
                                    type: 'LineEdit',
                                    title: self.ttr('ID'),
                                    property: { enabled: true },
                                    pack:
                                    {
                                        label: self.ttr('ID'),
                                    },
                                    state: function () {
                                        return 'hide';
                                    }
                                },
                                {
                                    name: 'name',
                                    type: 'LineEdit',
                                    title: self.ttr('Name'),
                                    property: {},
                                    pack:
                                    {
                                        label: self.ttr('Name')
                                    },
                                    validate: function (obj, val, title, moment, self) {
                                        if (val.trim() == '') {
                                            return [title + self.ttr(" can not be null!"), 'Error'];
                                        }
                                        else if (!val.match(new RegExp('^[A-Za-z0-9_]+$'))) {
                                            return [title + self.ttr(" can only contain [A-Za-z0-9_]!"), 'Error'];
                                        }

                                        return;
                                    }
                                },
                                {
                                    name: 'title_layout',
                                    type: 'HBoxLayout',
                                    title: self.ttr('Title'),
                                    property: {
                                        spacing: 10,
                                        margin: 0
                                    },
                                    pack: { label: self.ttr('Title') },
                                    child: [
                                        {
                                            name: 'title',
                                            type: 'LineEdit',
                                            property: {}, 
                                            validate: function (obj, val, title, moment, self) {
                                                if (val.trim() == '') {
                                                    return [title + self.ttr(" can not be null!"), 'Error'];
                                                }
                                            }
                                        },
                                        {
                                            type: 'PushButton',
                                            property: { text: self.ttr('Add Translation') },
                                            child: [
                                                {
                                                    type: 'Menu',
                                                    child: [
                                                        /*{% TITLE_I18N_ACTIONS %}*/
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                },
                                /*{% TITLE_I18N_WIDGETS %},*/
                                {
                                    name: 'units',
                                    title: self.ttr('Units'),
                                    type: 'LineEdit',
                                    property:
                                    {

                                    },
                                    pack:
                                    {
                                        label: self.ttr('Units')
                                    },
                                },
                                {
                                    name: 'department',
                                    title: self.ttr('Department'),
                                    type: 'MultiComboBox',
                                    property:
                                    {
                                        item_list: TOPENM.enumList("pdm-attrname-department").toComboList(),
                                        name_format: 'A,B'
                                    },
                                    pack:
                                    {
                                        label: self.ttr('Department')
                                    },
                                    getter: function (obj, self) {
                                        return obj.getData("current_names");
                                    },
                                    setter: function (obj, value, self) {
                                        obj.setData('value', value.join(','));
                                    }
                                },
                                {
                                    name: 'category',
                                    title: self.ttr('Category'),
                                    type: 'MultiComboBox',
                                    property:
                                    {
                                        item_list: TOPENM.enumList("pdm-attrname-attrcategory").toComboList(),
                                        name_format: 'A,B'
                                    },
                                    pack:
                                    {
                                        label: self.ttr('Category')
                                    },
                                    getter: function (obj, self) {
                                        return obj.getData("current_names");
                                    },
                                    setter: function (obj, value, self) {
                                        obj.setData('value', value.join(','));
                                    }
                                },
                                {
                                    name: 'type',
                                    title: self.ttr('Attribute Type'),
                                    type: 'MultiComboBox',
                                    property:
                                    {
                                        item_list: TOPENM.enumList("pdm-attrname-attrtype").toComboList(),
                                        size_policy: 'Expanding,fixed',
                                        name_format: 'A,B'
                                    },
                                    pack:
                                    {
                                        label: self.ttr('Attribute Type')
                                    },
                                    validate: 'NotNull',
                                    getter: function (obj, self) {
                                        return obj.getData("current_names");
                                    },
                                    setter: function (obj, value, self) {
                                        obj.setData('value', value.join(','));
                                    }
                                },
                                {
                                    name: 'data_type',
                                    title: self.ttr('Data Type'),
                                    type: 'ComboBox',
                                    property:
                                    {
                                        item_list: TOPENM.enumList("pdm-attrname-datatype").toComboList(),
                                        size_policy: 'Expanding,fixed',
                                        name_format: 'A,B'
                                    },
                                    pack:
                                    {
                                        label: self.ttr('Data Type')
                                    },
                                    validate: function (obj, val, title, moment, self) {
                                        if (val.trim() == '') {
                                            return [title + self.ttr(" can not be null!"), 'Error'];
                                        }

                                    },
                                },
                                {
                                    name: 'option_list_box',
                                    type: 'GroupBox',
                                    pack: {
                                        label: self.ttr("Option List")
                                    },
                                    property: {
                                        label: self.ttr("Option List")
                                    },
                                    state: function (obj, self) {
                                        var list = ["enum", "editable_enum", "check_box", "radio_box",
                                            "multiple_enum", "multiple_check", "drill_cu_thick"];
                                        var dataType = this.getValue("data_type");
                                        if (list.indexOf(dataType) == -1) {
                                            return 'hide';
                                        } else {
                                            // 当为单选可编辑时，由于编辑的是选项的namne，所以不显示text
                                            var optionLstView = this.getObject("option_list");
                                            if (optionLstView !== null) {
                                                optionLstView.setColumnVisible("text", (dataType !== "editable_enum"));
                                            }
                                            return "Show";
                                        }
                                    },
                                    child: [ {
                                            name: 'vlayout',
                                            type: 'VBoxLayout',
                                            property: {
                                                spacing: 0,
                                                margin: 0
                                            },
                                            pack: {},
                                            child: [
                                                {
                                                    name: 'toolbar',
                                                    type: 'ToolBar',
                                                    property: {},
                                                    pack: {},
                                                    child: [
                                                        {
                                                            name: 'yesno',
                                                            type: 'Action',
                                                            property:
                                                            {
                                                                text: self.ttr('Defalt Yes/No'),
                                                                icon: 'pdm-default.#54698d',
                                                                shortcut: '',
                                                                tooltip: '',
                                                                style: 'size=small  button_style=icon'
                                                            },
                                                            callback: function (obj, checked, self) {
                                                                var datType = this.getObject('data_type').getData('value');
                                                                var optionList = [];
                                                                if ('check_box' === datType) {
                                                                    optionList = [
                                                                        {
                                                                            "data": "",
                                                                            "icon": "",
                                                                            "name": "1",
                                                                            "rmk": "",
                                                                            "text": "Yes"
                                                                        },
                                                                        {
                                                                            "data": "",
                                                                            "icon": "",
                                                                            "name": "0",
                                                                            "rmk": "",
                                                                            "text": "No"
                                                                        }
                                                                    ];
                                                                } else {
                                                                    optionList = [
                                                                        {
                                                                            "data": "",
                                                                            "icon": "",
                                                                            "name": "Yes",
                                                                            "rmk": "",
                                                                            "text": "Yes"
                                                                        },
                                                                        {
                                                                            "data": "",
                                                                            "icon": "",
                                                                            "name": "No",
                                                                            "rmk": "",
                                                                            "text": "No"
                                                                        }
                                                                    ];
                                                                }
                                                                this.getObject('option_list').loadData(optionList);
                                                            },
                                                        },
                                                        {
                                                            name: 'new',
                                                            type: 'Action',
                                                            property:
                                                            {
                                                                text: self.ttr('New Option'),
                                                                icon: 'addto-circle-o.#54698d',
                                                                shortcut: '',
                                                                tooltip: '',
                                                                style: 'size=small  button_style=icon'
                                                            },
                                                            callback: function (obj, checked, self) {
                                                                self.callAction("add_option");
                                                            },
                                                        },
                                                        {
                                                            name: 'edit',
                                                            type: 'Action',
                                                            property:
                                                            {
                                                                text: self.ttr('Edit Option'),
                                                                icon: 'edit.#54698d',
                                                                shortcut: '',
                                                                tooltip: '',
                                                                style: 'size=small  button_style=icon'
                                                            },
                                                            callback: function (obj, checked, self) {
                                                                self.callAction("edit_option");
                                                            },
                                                        },
                                                        {
                                                            name: 'delete',
                                                            type: 'Action',
                                                            property:
                                                            {
                                                                text: self.ttr('Remove Option'),
                                                                icon: 'minus-circle-o.#54698d',
                                                                shortcut: '',
                                                                tooltip: '',
                                                                style: 'size=small  button_style=icon'
                                                            },
                                                            callback: function (obj, checked, self) {
                                                                self.callAction("remove_option");
                                                            },
                                                        },
                                                        {
                                                            name: 'refresh',
                                                            type: 'Action',
                                                            property:
                                                            {
                                                                text: self.ttr('Refresh'),
                                                                icon: 'refresh.#54698d',
                                                                shortcut: '',
                                                                tooltip: '',
                                                                style: 'size=small  button_style=icon'
                                                            },
                                                            callback: function (obj, checked, self) {
                                                                self.callAction("refresh_detail");
                                                            },
                                                        },
                                                        {
                                                            name: 'separator',
                                                            type: 'Separator',
                                                        },
                                                        {
                                                            name: 'move_top',
                                                            type: 'Action',
                                                            property:
                                                            {
                                                                text: self.ttr('Arrow top'),
                                                                icon: 'angle-double-up',
                                                                shortcut: '',
                                                                tool_tip: self.ttr('Arrow top'),
                                                                style: 'size = small'
                                                            },
                                                            callback: function (obj, checked, self) {
                                                                this.getObject('option_list').moveSelectedRowsTop();
                                                            },
                                                        },
                                                        {
                                                            name: 'move_up',
                                                            type: 'Action',
                                                            property:
                                                            {
                                                                text: self.ttr('Arrow up'),
                                                                icon: 'angle-up',
                                                                shortcut: '',
                                                                tool_tip: self.ttr('Arrow up'),
                                                                style: 'size = small'
                                                            },
                                                            callback: function (obj, checked, self) {
                                                                this.getObject('option_list').moveSelectedRowsUp();
                                                            },
                                                        },
                                                        {
                                                            name: 'move_down',
                                                            type: 'Action',
                                                            property:
                                                            {
                                                                text: self.ttr('Arrow down'),
                                                                icon: 'angle-down',
                                                                shortcut: '',
                                                                tool_tip: self.ttr('Arrow down'),
                                                                style: 'size = small'
                                                            },
                                                            callback: function (obj, checked, self) {
                                                                this.getObject('option_list').moveSelectedRowsDown();
                                                            },
                                                        },
                                                        {
                                                            name: 'move_btm',
                                                            type: 'Action',
                                                            property:
                                                            {
                                                                text: self.ttr('Arrow bottom'),
                                                                icon: 'angle-double-down',
                                                                shortcut: '',
                                                                tool_tip: self.ttr('Arrow bottom'),
                                                                style: 'size = small'
                                                            },
                                                            callback: function (obj, checked, self) {
                                                                this.getObject('option_list').moveSelectedRowsBottom();
                                                            },
                                                        },
                                                    ]
                                                },
                                                {
                                                    name: 'option_list',
                                                    type: 'TableView',
                                                    property: { minimum_height: 200 },
                                                    pack: {},
                                                    getter: function (obj, self) {
                                                        var data = obj.allDataMap();
                                                        return TDataParse.variant2JsonStr(data);
                                                    },
                                                    setter: function (obj, value) {
                                                        var data = [];
                                                        if (value != null) {
                                                            data = TDataParse.jsonStr2Variant(value);
                                                        }
                                                        obj.loadData(data);
                                                    },
                                                    initCallback: function (obj) {
                                                        obj.setHeaderItem(
                                                            [
                                                                {
                                                                },
                                                                {
                                                                    "name": "name",
                                                                    "display": self.ttr("Name"),
                                                                    "resizeMode": "Interactive",
                                                                    "size": "100",
                                                                    "displayRole": "$name"
                                                                },
                                                                {
                                                                    "name": "text",
                                                                    "display": self.ttr("Text"),
                                                                    "resizeMode": "Interactive",
                                                                    "size": "80",
                                                                    "displayRole": "$text"
                                                                },
                                                                {
                                                                    "name": "icon",
                                                                    "display": self.ttr("Icon"),
                                                                    "resizeMode": "Interactive",
                                                                    "size": "120",
                                                                    "displayRole": "$icon",
                                                                    "decorationRole": "$icon"
                                                                },
                                                                {
                                                                    "name": "data",
                                                                    "display": self.ttr("Data"),
                                                                    "resizeMode": "Interactive",
                                                                    "size": "100",
                                                                    "displayRole": "$data"
                                                                },
                                                                {
                                                                    "name": "rmk",
                                                                    "display": self.ttr("Remark"),
                                                                    "resizeMode": "Interactive",
                                                                    "size": "100",
                                                                    "displayRole": "$rmk"
                                                                }
                                                            ]);
                                                        obj.setDataKeyList(["name", "text", "icon", "data", "rmk", "text_en", "text_zhcn", "text_zhtw"]);
                                                        obj.setPrimaryKey("name");
                                                    },
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    name: 'ui_cfg',
                                    title: self.ttr('UI Cfg'),
                                    type: 'CodeEdit',
                                    property:
                                    {
                                        min: 1, max: 30,
                                        acceptRichText: false
                                    },
                                    pack:
                                    {
                                        label: self.ttr('UI Cfg'),
                                    },
                                },
                                {
                                    name: 'tags',
                                    title: self.ttr('Tag'),
                                    type: 'Chips',
                                    property:
                                    {

                                    },
                                    pack:
                                    {
                                        label: self.ttr('Tag'),
                                    },
                                },
                                {
                                    name: 'remark',
                                    title: self.ttr('Remark'),
                                    type: 'PlainTextEdit',
                                    property:
                                    {
                                        acceptRichText: false, min_row_count: 1, max_row_count: 30
                                    },
                                    pack:
                                    {
                                        label: self.ttr('Remark'),
                                    },
                                },

                            ]
                        },
                        {
                            name: 'stretcher',
                            type: 'Widget',
                            property: { size_policy: 'Qt::Expanding' }
                        }
                    ]
                }
            ]
        }
    ];
}
