function func(self) {
    return [
        {
            name: 'scrollarea',
            type: 'ScrollArea',
            property:
            {
                widget_resizable: true,
                frame_shape: 'QFrame::NoFrame'
            },
            pack: {},
            child:
            {
                name: 'vlayout',
                type: 'VBoxLayout',
                property:
                {
                    margin: 0, spacing: 10
                },
                pack: {},
                child: [
                    {
                        name: 'flayout',
                        type: 'FormGridLayout',
                        property:
                        {
                            label_alignment: 'AlignRight', margin: 20, vertical_spacing: 10, horizontal_spacing: 20
                        },
                        pack: {},
                        child: [
                            {
                                name: 'name',
                                type: 'LineEdit',
                                property: {},
                                title: self.ttr("Name"),
                                pack:
                                {
                                    label: self.ttr("Name")
                                },
                                validate: function (obj, val, title, moment, self) {
                                    if (val.trim() == '') {
                                        return [title + self.ttr('can not be null'), 'Error'];
                                    }
                                    return;
                                },
                                initCallback: function (obj, self) {
                                    obj.setFocus();
                                }
                            },
                            {
                                name: "text_wgt",
                                type: "Widget",
                                pack: { label: self.ttr("Text") },
                                child: {
                                    name: 'text_layout',
                                    type: 'HBoxLayout',
                                    property: {
                                        margin: 0,
                                        spacing: 10
                                    },
                                    child: [
                                        {
                                            name: 'text',
                                            type: 'LineEdit',
                                            title: self.ttr('Text'),
                                            property: {},
                                            validate: function (obj, val, title, moment, self) {
                                                return;
                                            }
                                        },
                                        {
                                            type: 'PushButton',
                                            property: { text: self.ttr('Add Translation') },
                                            child: [
                                                {
                                                    type: 'Menu',
                                                    child: [
                                                        /*{% TITLE_I18N_ACTIONS %}*/
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                },
                                state: function (obj, self) {
                                    var option_list_table = self.uiLoader().getObject("option_list");
                                    if (option_list_table == undefined || option_list_table === null) return;
                                    return option_list_table.isColumnVisible("text") ? "SHOW" : "HIDE";
                                }
                            },
                            /*{% TITLE_I18N_WIDGETS %},*/
                            {
                                name: 'icon',
                                type: 'IconSelector',
                                title: self.ttr('Icon'),
                                property: {},
                                pack:
                                {
                                    label: self.ttr('Icon')
                                },
                            },
                            {
                                name: 'data',
                                title: self.ttr('Data'),
                                type: 'TextEdit',
                                property: { min_row_count: 1, max_row_count: 30 },
                                pack:
                                {
                                    label: self.ttr('Data')
                                },
                                setter: function (obj, value, self) {
                                    obj.setPlainText(value);
                                },
                                getter: function (obj, self) {
                                    return obj.plainText
                                },
                            },
                            {
                                name: 'rmk',
                                title: self.ttr('Remark'),
                                type: 'TextEdit',
                                property: { min_row_count: 1, max_row_count: 30 },
                                pack:
                                {
                                    label: self.ttr('Remark')
                                },
                                setter: function (obj, value, self) {
                                    obj.setPlainText(value);
                                },
                                getter: function (obj, self) {
                                    return obj.plainText
                                },
                            },
                            {
                                name: 'stretcher',
                                type: 'Widget',
                                property: { size_policy: 'Qt::Expanding' }
                            }
                        ]
                    }
                ]
            }
        }
    ]
        ;
}