importPackage("moment");
importPackage('ikm.ole');

function exportToExcel(field_text_list, field_name_list, allData, excel) {
    //表头字段
    for (var i = 0; i< field_text_list.length; i++) {
        var range = String.fromCharCode(65 + i) + "1";
        excel.setRangeValue(range, field_text_list[i]);
        excel.setRangeHorizontalAlignment(range, -4108);//-4108 x1center 水平居中
        var font_map = {
            Size: 12,
            Bold: true,
            Color: -11480942,
            ThemeColor: 1
        };
        excel.setRangeFont(range, font_map);
        excel.setRangeBackgroundColor(range, '#64CC33'); //背景色设为绿色
        excel.autoFitColumns(String.fromCharCode(65 + i));
    }

    //数据
    var row = 2;
    _.forEach(allData, function (v) {
        var j = 0;
        _.forEach(field_name_list, function (v2) {
            var cell = excel.getCell(row, j + 1);
            excel.setCellValue(cell, _.toString(v[v2]));
            j++;
        })
        row++;
    })

    //边框
    var row = excel.getUsedRows();
    var column = excel.getUsedColumns();
    var rangecolunmn = String.fromCharCode(65 + column - 1);
    var used_range = _.format("A1:{0}{1}", rangecolunmn, row);
    var border = {
        Color: -4165632,
        LineStyle: 1,
        TintAndShader: 0,
        Weight: 2
    };
    excel.setRangeBorder(used_range, border);
}
function treeData2TableData(iDataLst, iChildrenKey) {
    var allDataLst = [];
    _.forEach(iDataLst, function (item) {
        var childrenLst = item[iChildrenKey];
        delete item[iChildrenKey];
        allDataLst.push(item);
        if (!_.isEmpty(childrenLst)) {
            allDataLst = allDataLst.concat(treeData2TableData(childrenLst, iChildrenKey));
        }
    })
    return allDataLst;
}

try {
    var self = this;
    var chooseDlg = new TTableChooserDialog();
    chooseDlg.setTitle(this.ttr("Select Export Tab"));
    chooseDlg.setHeaderItem([
        {},
        {
            "name": "name",
            "display": self.ttr("Name"),
            "displayRole": "$name",
            "resizeMode": "Stretch"
        }
    ]);
    chooseDlg.setPrimaryKey("index");
    chooseDlg.setDataKeyList(["index", "name"]);
    chooseDlg.loadAllData(this.allTabInfo());
    var selectedTabLst = chooseDlg.run();
    if (selectedTabLst.length == 0) {
        return;
    }
    var moduleName = String(this.moduleName());
    moduleName = moduleName.replace(/\-/g, " ");
    var fileName = _.format("{0} {1}.xlsx", moduleName, moment().format("YYYYMMDDHHmmss"));
    var fileDlg = new TFileDialog(this.ttr("Please select save file"), fileName);
    fileDlg.setNameFilters(["EXCEL(*.xlsx)"]);
    fileDlg.setAcceptMode("AcceptSave");
    var strLst = fileDlg.run();
    if (strLst.length == 0 ) {
        return;
    }
    var absoluteFileName = String(strLst[0]);

    var excel = new TExcel();
    excel.setExcelVisible(true);
    excel.addBook();

    var i = 1;
    _.forEach(selectedTabLst, function (v) {
        var index = _.toNumber(v['index']);
        var tabName = v['name'];
        var treeView = self.getTreeView(index);
        if (treeView) {
            if (i > excel.getSheetsCount()) {
                excel.appendSheet(tabName);
            }
            excel.selectSheet(i);
            excel.setSheetName(tabName);
            var headerItems = treeView.headerItem();
            var dataLst = treeView.allDataMap();
            var allData = treeData2TableData(dataLst, "CHILDREN");
            var field_text_list = [];
            var field_name_list = [];
            _.forEach(headerItems, function (v) {
                field_text_list.push(v['display']);
                field_name_list.push(v['displayRole'].replace('$', ''));
            });
            print("field_text_list" + _.toString(field_text_list));
            exportToExcel(field_text_list, field_name_list, allData, excel);
            i++;
        }
    })
    excel.saveAsBook(absoluteFileName.replace(/\//g, "\\"));
    excel.closeBook();
    excel.quitExcel();
    this.alertOk(this.ttr("Export success!"));
} catch (e) {
    print(e);
}

/*---ACTION---
ICON: "export"
LABEL: "Export Excel"
LABEL_ZHCN: "导出Excel"
LABEL_ZHTW: "導出Excel"
ACCEL: ""
TOOLTIP: "Export Excel"
TOOLTIP_ZHCN: "导出Excel"
TOOLTIP_ZHTW: "導出Excel"
PERMISSION: ""
CHECKED: ""
GROUP: ""
STYLE: "button_style=both"
LANG: "JavaScript"
STATUS: "Release"
VERSION: "1"
STATEHOOK: ""
---ACTION---*/