[
    {
        name: "basic_info_area",
        type: "ScrollArea",
        property: {
            widget_resizable: true,
            frame_shape: 'NoFrame'
        },
        pack: { label: self.ttr('Basic Info') },
        child: [
            {
                name: 'formlayout',
                type: 'FormGridLayout',
                property: {
                    // label_alignment: 'AlignTop | AlignRight',
                    // horizontal_spacing: 10,
                    // vertical_spacing: 10,
                    // margin: 10,
                    columns: 2
                },
                child: [ 
                    {
                        name: "id",
                        type: "LineEdit",
                        title: self.ttr(""),
                        pack: {column_span: 2},
                        initCallback: function(obj,value,self) {
                            obj.setVisible(false)
                        }
                    },
                    {
                        name: "attr_data.machine_code",
                        type: "LineEdit",
                        title: self.ttr("Machine Code"),
                        property: { readonly: true},
                        validate: 'NOTNULL',
                        child: [
                            {
                                name: "choose_machine",
                                type: "ToolButton",
                                property: {
                                    text: self.ttr("Choose")
                                },
                                callback: function(){
                                    var query = new TSqlQueryV2(T_SQLCNT_POOL.getSqlDatabase());
                                    var sql = "SELECT id,code,name FROM tpm_machine ORDER BY id DESC";
                                    try {
                                        var dialog = new TTableViewDialog(self)
                                        dialog.width = 400;
                                        dialog.height = 600;
                                        dialog.setTitle(self.ttr("Choose Machine"));
                                        dialog.setButtons([self.ttr('Ok')+':Ok:Ok:Primary',self.ttr('Cancel')+':Cancel:Cancel:ERROR']);
                                        dialog.setPrimaryKey('id');
                                        dialog.setSearchKeys(['code','name']);
                                        dialog.setHeaderItem(
                                            [
                                                {
                                                },
                                                {
                                                    name: 'id',
                                                    display: self.ttr('ID'),
                                                    displayRole: '$id'
                                                },
                                                {
                                                    name: 'code',
                                                    display: self.ttr('Machine Code'),
                                                    displayRole: '$code',
                                                    size: 100
                                                },
                                                {
                                                    name: 'name',
                                                    display: self.ttr('Machine Name'),
                                                    displayRole: '$name',
                                                    size: 200
                                                }
                                            ]
                                        );
                                        dialog.setDataKeyList(['id','code','name']);
                                        dialog.loadData(query.selectArrayMap(sql,{}));
                                        dialog.refreshData(true);
                                        var ret = dialog.run();
                                        if(_.isEmpty(ret)) return;
                                        this.getObject('attr_data.machine_code').setData('value',ret[0]['code']);
                                        this.getObject('attr_data.machine_name').setData('value',ret[0]['name']);
                                        this.getObject('machine_id').setData('value',ret[0]['id']);
                                    } catch(e) {
                                        GUI.msgbox({detail: e})
                                        print(e)
                                    }
                                }
                            }
                        ]
                    },
                    {
                        name: "attr_data.machine_name",
                        type: "LineEdit",
                        title: self.ttr("Machine Name"),
                        state: function(obj,self){
                            return 'disable';
                        }
                    },
                    {
                        name: "class",
                        type: "ComboBox",
                        title: self.ttr("Maintenance Type"),
                        property: {
                            item_list: TOPENM.enumList("tpm-machine-maintenance-plan-class").toComboList()
                        },
                        validate: 'NOTNULL'
                    },
                    {
                        name: "title",
                        type: "LineEdit",
                        title: self.ttr("Title"),
                    },
                    {
                        name: "priority",
                        type: "ComboBox",
                        title: self.ttr("Priority"),
                        property: {
                            item_list: TOPENM.enumList("tpm-machine-maintenance-plan-priority").toComboList()
                        },
                    },
                    {
                        name: "category",
                        type: "ComboBox",
                        title: self.ttr("Maintenance Category"),
                        property: {
                            item_list: TOPENM.enumList("tpm-machine-maintenance-plan-category").toComboList()
                        },
                    },
                    {
                        name: "execution_cycle",
                        type: "ComboBox",
                        title: self.ttr("Execution Type"),
                        property: {
                            item_list: TOPENM.enumList("tpm-machine-maintenance-plan-execution-cycle").toComboList()
                        },
                        validate: 'NOTNULL'
                    },
                    {
                        type: 'HBoxLayout',
                        title: self.ttr("Execution Cycle"),
                        state: function(obj,self){
                            if (this.getValue("execution_cycle") == "cycle"){
                                return 'show';
                            }
                            return 'hide';
                        },
                        child: [
                            {
                                name: "attr_data.cycle_value",
                                type: "IntLineEdit",
                                title: self.ttr("Cycle Value"),
                                state: function(obj,self){
                                    if (this.getValue("execution_cycle") == "cycle"){
                                        return 'show';
                                    }
                                    return 'hide';
                                },
                            },
                            {
                                name: "attr_data.cycle_unit",
                                type: "ComboBox",
                                title: self.ttr("Cycle Unit"),
                                state: function(obj,self){
                                    if (this.getValue("execution_cycle") == "cycle"){
                                        return 'show';
                                    }
                                    return 'hide';
                                },
                                property: {
                                    item_list: TOPENM.enumList("tpm-machine-maintenance-plan-cycle").toComboList()
                                },
                            }
                        ]
                    },
                    {
                        name: "last_execution_time",
                        type: "DateTimeEdit",
                        title: self.ttr("Last Execution Time"),
                        state: function(obj,self){
                            return 'disable';
                        },
                        getter: function(obj,self){
                            if(_.isEmpty(obj.getData())){
                                return null;
                            }
                            return obj.getData();
                        }
                    },
                    {
                        name: "next_execution_time",
                        type: "DateTimeEdit",
                        title: self.ttr("Next Execution Time"),
                        getter: function(obj,self){
                            if(_.isEmpty(obj.getData())){
                                return null;
                            }
                            return obj.getData();
                        },
                        validate: "NOTNULL"
                    },
                    {
                        name: "status",
                        type: "ComboBox",
                        title: self.ttr("Status"),
                        property: {
                            item_list: TOPENM.enumList("tpm-machine-maintenance-plan-status").toComboList()
                        }
                    },
                    {
                        type: 'HBoxLayout'
                    },
                    {
                        name: "maintenance_person_name",
                        type: "LineEdit",
                        title: self.ttr("Maintenance Person"),
                        pack: {column_span: 2},
                        getter: function(obj,self){
                            if (_.isEmpty(obj.getData())){
                                return null;
                            }
                            return obj.getData().split(',');
                        },
                        setter: function(obj,val,self){
                            if (_.isEmpty(val))return;
                            val = val.replace('{','[');
                            val = val.replace('}',']');
                            obj.setData('value',eval('(' + val + ')').join(','))
                        },
                        child: [
                            {
                                name: "choose_person",
                                type: "ToolButton",
                                property: {
                                    text: self.ttr("Choose")
                                },
                                callback: function(){
                                    var query = new TSqlQueryV2(T_SQLCNT_POOL.getSqlDatabase());
                                    var sql = "SELECT id,fullname FROM sys_user ORDER BY id DESC";
                                    try {
                                        var dialog = new TTableViewDialog(self)
                                        dialog.width = 400;
                                        dialog.height = 600;
                                        dialog.setTitle(self.ttr("Choose Person"));
                                        dialog.setButtons([self.ttr('Ok')+':Ok:Ok:Primary',self.ttr('Cancel')+':Cancel:Cancel:ERROR']);
                                        dialog.setPrimaryKey('id');
                                        dialog.setSearchKeys(['fullname']);
                                        dialog.setSelectionMode(3);
                                        dialog.setHeaderItem(
                                            [
                                                {
                                                },
                                                {
                                                    name: 'id',
                                                    display: self.ttr('ID'),
                                                    displayRole: '$id'
                                                },
                                                {
                                                    name: 'fullname',
                                                    display: self.ttr('Name'),
                                                    displayRole: '$fullname',
                                                    size: 200
                                                }
                                            ]
                                        );
                                        dialog.setDataKeyList(['id','fullname']);
                                        dialog.loadData(query.selectArrayMap(sql,{}));
                                        dialog.refreshData(true);
                                        var ret = dialog.run();
                                        if(_.isEmpty(ret)) return;
                                        var idList = [];
                                        var nameList = [];
                                        _.each(ret,function(people){
                                            idList.push(people.id);
                                            nameList.push(people.fullname)
                                        });
                                        this.getObject('maintenance_person_name').setData('value',nameList.join(','));
                                        this.getObject('maintenance_person_ids').setData('value',idList.join(','));
                                    } catch(e) {
                                        GUI.msgbox({detail: e})
                                        print(e)
                                    }
                                }
                            }
                        ]
                    },
                    {
                        name: "description",
                        type: "PlainTextEdit",
                        title: self.ttr("Maintenance Content"),
                        pack: {column_span: 2},
                        property: {
                            min_row_count: 8
                        }
                    },
                    {
                        name: "maintenance_person_ids",
                        type: "LineEdit",
                        pack: {column_span: 2},
                        initCallback: function(obj,value,self) {
                            obj.setVisible(false)
                        },
                        getter: function(obj,self){
                            if (_.isEmpty(obj.getData())){
                                return null;
                            }
                            return obj.getData().split(',');
                        },
                        setter: function(obj,val,self){
                            if (_.isEmpty(val))return;
                            val = val.replace('{','[');
                            val = val.replace('}',']');
                            obj.setData('value',eval('(' + val + ')').join(','))
                        },
                    },
                    {
                        name: "machine_id",
                        type: "LineEdit",
                        initCallback: function(obj,value,self) {
                            obj.setVisible(false)
                        }
                    },
                    {
                        type: 'Stretch'
                    }
                ]
            }
        ]
    }
]