this.masterWillUpdate = function(ARG) {
    try {
        var masterSelector = new TSqlSelectorV2();
        masterSelector.setTable("tpm_machine");
        masterSelector.setField(this.masterQueryFields());

        var searchEntry = this.uim().getWidget("MASTER_TOOLBAR/SEARCH_ENTRY");
        if (searchEntry !== null) {
            masterSelector.addWhere(searchEntry.sqlWhere());
        }
        var query = new TSqlQueryV2(T_SQLCNT_POOL.getSqlDatabase());
        var rowCount = query.selectCount(masterSelector);

        masterSelector.setPage(ARG.pageNum, ARG.pageSize);
        masterSelector.setOrder('id', 1); // DESC
        var error = new TError;
        var dataLst = this.runSqlQueryOnThreadSync('TOPSQLTHREAD_SELECT_ARRAYMAP', masterSelector, error);
        if (error.isValid()) {
            throw error.text();
        }
        this.loadMasterData(dataLst, rowCount);
    } catch(e) {
        print(e);
    }
}

this.slaveWillUpdate = function(iMasterPrimaryKey, iArgMap) {
    try {
        var slaveSelector = new TSqlSelectorV2();
        slaveSelector.setTable("tpm_machine_maintance_plan_v2");
        slaveSelector.setField(this.slaveQueryFields());
        slaveSelector.setWhere("machine_id", iMasterPrimaryKey);
        var searchEntry = this.uim().getWidget("SLAVE_TOOLBAR/SEARCH_ENTRY");
        if (searchEntry !== null) {
          slaveSelector.addWhere(searchEntry.sqlWhere());
        }
        slaveSelector.setFieldFormat({"action_data": "json", "trigger_param": "json"});
        if (!_.isEmpty(iArgMap)) {
            slaveSelector.setPage(_.get(iArgMap, "pageNum"), _.get(iArgMap, "pageSize"));
        }
        var error = new TError();
        var dataLst = this.runSqlQueryOnThreadSync('TOPSQLTHREAD_SELECT_ARRAYMAP', slaveSelector, error);
        if (error.isValid()) {
            throw error.text();
        }
        if (_.get(iArgMap, "resetPage")) {
            var rowCount = this.runSqlQueryOnThreadSync('TOPSQLTHREAD_SELECT_COUNT', slaveSelector, error);
            if (error.isValid()) {
                throw error.text();
            }
            this.insertSlaveCount(iMasterPrimaryKey, rowCount);
        }
        
        this.insertSlaveData(iMasterPrimaryKey, dataLst);
    } catch (e) {
        print(e);
    }
}
