try {
    var selectedSlaveItems = this.selectedSlaveItems();
    if (selectedSlaveItems.length == 0) {
        return;
    }
    var id = selectedSlaveItems[0];
    var dataMap = {
        "status": "active",
        "action_data": {
            "last_active_time": APP.getNow()
        }
    }
    var updater = new TSqlUpdaterV2;
    updater.setTable("tpm_machine_maintance_plan_v2");
    updater.setData(dataMap);
    updater.setUpdatePolicy({"action_data": "json_merge"});
    updater.setWhere("id", id);
    var error = new TError;
    this.runSqlQueryOnThreadSync("TOPSQLTHREAD_UPDATE_ROW", updater, error);
    if (error.isValid()) {
        throw error.text();
    }
    this.refreshSlave();
} catch (e) {
    print(e);
}

/*---ACTION---
ICON: ""
LABEL: "Active Plan"
LABEL_ZHCN: "启用计划"
LABEL_ZHTW: "啟用計劃"
ACCEL: ""
TOOLTIP: "Active Plan"
TOOLTIP_ZHCN: "启用计划"
TOOLTIP_ZHTW: "啟用計劃"
CHECKED: ""
GROUP: ""
STYLE: "button_style=text"
LANG: "JavaScript"
STATUS: "Release"
VERSION: "1"
STATEHOOK: "return !_.isEmpty(this.selectedSlaveItems()) ? 'enable' : 'disable';"
---ACTION---*/