try {
    var self = this;
    var selectedSlaveItems = this.selectedSlaveItems();
    if (selectedSlaveItems.length == 0) {
        return;
    }
    var ret = GUI.showForm({
        title: self.ttr('Delete'),
        self: self,
        use_core_engine: true,
        items: {
            type: "VBoxLayout",
            property: {
                margin: 20,
                spacing: 10
            },
            child: [
                {
                    type: "Label",
                    property: { text: self.ttr("Are you sure to remove selected items?") }
                },
                {
                    name: "related_delete",
                    type: "CheckBox",
                    property: { text: self.ttr('Also delete related task?'), tristate: false }
                }
            ]
        },
        size: '400x200',
        buttons: [
            self.ttr('Delete') + ':Ok:Ok:Primary',
            self.ttr('Cancel') + ':Cancel:Cancel:Error'
        ]
    })
    if (_.isEmpty(ret)) {
        return;
    }
    var sql = _.format("delete from tpm_machine_maintance_plan_v2 where id in ('{0}')", selectedSlaveItems.join("','"));
    if (ret["related_delete"] == 1) {
        // 同时删除计划及该计划在tpm_maintance_record 中状态为未开始执行的任务及任务对应在tpm_maintance_record_detail中的数据
        sql = _.format("with DP(id) as (delete from tpm_machine_maintance_plan_v2 where id in ('{0}') returning id),\
        DR(id) as (delete from tpm_machine_maintance_record_v2 where plan_id in (select id from DP) and status = 'waiting'  returning id)   \
        delete from tpm_machine_maintance_record_detail where record_id in (select id from DR)", selectedSlaveItems.join("','"));
    }
    var error = new TError;
    this.runSqlQueryOnThreadSync("TOPSQLTHREAD_EXEC_SQL", sql,  error);
    if (error.isValid()) {
        throw error.text();
    }
    this.refreshSlave();
} catch (e) {
    print(e);
}

/*---ACTION---
ICON: ""
LABEL: "Delete Plan"
LABEL_ZHCN: "删除计划"
LABEL_ZHTW: "刪除計劃"
ACCEL: ""
TOOLTIP: "Delete Plan"
TOOLTIP_ZHCN: "删除计划"
TOOLTIP_ZHTW: "刪除計劃"
CHECKED: ""
GROUP: ""
STYLE: "button_style=text"
LANG: "JavaScript"
STATUS: "Release"
VERSION: "1"
STATEHOOK: "return !_.isEmpty(this.selectedSlaveItems()) ? 'enable' : 'disable';"
---ACTION---*/