function func(self) {
    var uiItems = {
        name: 'layout',
        type: 'FormLayout',
        property: {
            label_alignment: 'AlignTop | AlignRight',
            horizontal_spacing: 20,
            vertical_spacing: 10,
            margin: 20
        },
        child: [
            {
                name: 'item',
                type: 'LineEdit',
                property: {},
                pack: { label: self.ttr('Maintance Item') },
                validate: 'NOTNULL'
            },
            {
                name: 'method',
                type: 'LineEdit',
                property: {},
                pack: { label: self.ttr('Maintance Method') },
                validate: "NOTNULL"
            },
            {
                name: 'spec_value',
                type: 'DoubleLineEdit',
                property: {},
                pack: { label: self.ttr('Spec Value') },
                validate: function (obj, val, title, moment, self) {
                    var auto_judge_policy = this.getValue("auto_judge_policy")
                    if (auto_judge_policy == "ng_not_equal_spec" && val == undefined) {
                        return title + " " + self.ttr(" can not be null!");
                    }
                }
            },
            {
                name: 'max_value',
                type: 'DoubleLineEdit',
                property: {},
                pack: { label: self.ttr('Max Value') },
                validate: function (obj, val, title, moment, self) {
                    var auto_judge_policy = this.getValue("auto_judge_policy")
                    if (auto_judge_policy == "ng_bigger_than_min" && val == undefined) {
                        return title + " " + self.ttr(" can not be null!");
                    }
                }
            },
            {
                name: 'min_value',
                type: 'DoubleLineEdit',
                property: {},
                pack: { label: self.ttr('Min Value') },
                validate: function (obj, val, title, moment, self) {
                    var auto_judge_policy = this.getValue("auto_judge_policy")
                    if (auto_judge_policy == "ng_less_than_min" && val == undefined) {
                        return title + " " + self.ttr(" can not be null!");
                    }
                }
            },
            {
                name: 'auto_judge_policy',
                type: 'ComboBox',
                property: {
                    item_list: TOPENM.enumList("tpm-machine-maintance-plan-auto-judge-policy").toComboList()
                },
                pack: { label: self.ttr('Auto Judge Policy') },
                validate: "NOTNULL"
            }
        ]
    };
    return [
        {
            name: "tabWidget",
            type: "TabWidget",
            child: [
                {
                    type: "FormLayout",
                    pack: { label: self.ttr("Basic Information") },
                    property: {

                    },
                    child: [
                        {
                            name: "table(slave).id",
                            type: "IntLineEdit",
                            title: self.ttr(""),
                            state: function (obj, self) {
                                return 'hide';
                            },
                            setter: function (obj, value, self) {
                                obj.text = value;
                                var planDetailLst = [];
                                if (!_.isEmpty(_.toString(value))) {
                                    var query = new TSqlQueryV2(T_SQLCNT_POOL.getSqlDatabase());
                                    try {
                                        planDetailLst = query.selectArrayMap({
                                            table: "tpm_machine_maintance_plan_detail",
                                            field: ["id", "item", "method", "spec_value", "max_value", "min_value", "auto_judge_policy"],
                                            where: { "plan_id": value }
                                        })
                                        if (query.lastError().isValid()) {
                                            throw query.lastError().text();
                                        }
                                        this.getObject("plan_detail").loadData(planDetailLst);
                                    } catch (e) {
                                        print(e);
                                    }
                                }
                            }
                        },
                        {
                            name: "table(slave).machine_id",
                            type: "IntLineEdit",
                            title: self.ttr(""),
                            state: function (obj, self) {
                                return 'hide';
                            }
                        },
                        {
                            name: "table(slave).name",
                            type: "LineEdit",
                            title: self.ttr("Plan Name")
                        },
                        {
                            name: "table(slave).description",
                            type: "LineEdit",
                            title: self.ttr("Plan Desc")
                        },
                        {
                            name: "table(slave).type",
                            type: "ComboBox",
                            title: self.ttr("Plan Type"),
                            property: {
                                item_list: TOPENM.enumList("tpm-machine-maintance-plan-type").toComboList()
                            }
                        },
                        {
                            name: "table(slave).action_data.create_time",
                            type: "DateTimeEdit",
                            title: self.ttr("Create Time")
                        },
                        {
                            name: "table(slave).action_data.last_active_time",
                            type: "DateTimeEdit",
                            title: self.ttr("Last Active Time")
                        },
                        {
                            name: "table(slave).action_data.last_inactive_time",
                            type: "DateTimeEdit",
                            title: self.ttr("Last Inactive Time")
                        },
                        {
                            name: "table(slave).remark",
                            type: "PlainTextEdit",
                            title: self.ttr("Remark"),
                            property: {
                                min_row: 3,
                                max_row: 6
                            }
                        }
                    ]
                },
                {
                    type: "FormLayout",
                    pack: { label: self.ttr("Spec Frequency") },
                    child: [
                        {
                            name: "table(slave).trigger_type",
                            title: self.ttr("Trigger Type"),
                            type: "RadioBox",
                            property: {
                                item_list: TOPENM.enumList("tpm-machine-maintance-plan-trigger-type").toComboList()
                            },
                            validate: function(obj, val, title, moment, self) {
                                var mThis = this;
                                mThis.setState("trigger_param", "hide");
                                mThis.setState("table(slave).trigger_func", "hide");
                                if (obj.currentName == "crontab") {
                                    mThis.setState("trigger_param", "show");
                                    mThis.setState("table(slave).trigger_func", "hide");
                                } else if (obj.currentName == "customize") {
                                    mThis.setState("trigger_param", "hide");
                                    mThis.setState("table(slave).trigger_func", "show");
                                } else {
                                    mThis.setState("trigger_param", "hide");
                                    mThis.setState("table(slave).trigger_func", "hide");
                                }
                            }
                        },
                        {
                            name: 'trigger_param',
                            type: 'Widget',
                            title: self.ttr('Trigger Param'),
                            "formula": function(obj, self) {
                                var curname = this.getValue("table(slave).trigger_type");
                                print("curname" + curname)
                                var mThis = this;
                                if (curname == "crontab") {
                                    mThis.setState("trigger_param", "show");
                                    mThis.setState("table(slave).trigger_func", "hide");
                                } else if (curname == "customize") {
                                    mThis.setState("trigger_param", "hide");
                                    mThis.setState("table(slave).trigger_func", "show");
                                } else {
                                    mThis.setState("trigger_param", "hide");
                                    mThis.setState("table(slave).trigger_func", "hide");
                                }
                            },
                            "formulaTrigger": ['EDIT', 'table(slave).trigger_type'],
                            child: [
                                {
                                    type: "HBoxLayout",
                                    property: {
                                        margin: 0,
                                        spacing: 10
                                    },
                                    child: [
                                        {
                                            type: "Label",
                                            property: {
                                                text: self.ttr("per")
                                            }
                                        },
                                        {
                                            name: "table(slave).trigger_param.cycle_time",
                                            pack: { label: self.ttr("每") },
                                            type: "LineEdit",
                                            child: {
                                                name: 'table(slave).trigger_param.cycle_time_unit',
                                                type: 'ComboBox',
                                                property: {
                                                    item_list: TOPENM.enumList("tpm-machine-maintance-plan-time-unit").toComboList(),
                                                    stylesheet: "background-color: white;border: 0px;border-left: 1px solid lightgray;"
                                                }
                                            }
                                        }
                                    ]
                                }
                            ]
                        },
                        {
                            name: "table(slave).trigger_func",
                            type: "PlainTextEdit",
                            pack: { label: self.ttr("Trigger Function") },
                            title: self.ttr("Trigger Function"),
                            property: {

                            }
                        }
                    ]
                },
                {
                    type: "FormGridLayout",
                    pack: { label: self.ttr("Maintance Plan Detail") },
                    child: [
                        {
                            type: "ToolBar",
                            child: [
                                {
                                    name: 'add_btn',
                                    type: 'Action',
                                    property: {
                                        text: self.ttr('Add'),
                                        icon: 'plus',
                                        shortcut: '',
                                        tooltip: '',
                                        style: 'size=small  button_style=icon'
                                    },
                                    callback: function (obj, checked, self) {
                                        try {
                                            var ret = GUI.showForm({
                                                title: self.ttr('Add'),
                                                self: self,
                                                use_core_engine: true,
                                                items: uiItems,
                                                size: '500x400',
                                                buttons: [
                                                    self.ttr('Add') + ':Ok:Ok:Primary',
                                                    self.ttr('Cancel') + ':Cancel:Cancel:Error'
                                                ],
                                                include_hidden_items: true
                                            });
                                            if (_.isEmpty(ret)) {
                                                return;
                                            }
                                            print("ret" + _.toString(ret));
                                            ret["id"] = APP.getNow();
                                            ret["CRUD"] = "create";
                                            this.getObject('plan_detail').appendRow(ret);
                                        }
                                        catch (e) {
                                            TMessageBox.error(this, '', e);
                                            print(e)
                                        }
                                    }
                                },
                                {
                                    name: 'edit_btn',
                                    type: 'Action',
                                    property: {
                                        text: self.ttr('Edit'),
                                        icon: 'edit',
                                        shortcut: '',
                                        tooltip: '',
                                        style: 'size=small button_style=icon'
                                    },
                                    callback: function (obj, checked, self) {
                                        try {
                                            var plan_detail = this.getObject("plan_detail");
                                            var selectedDatas = plan_detail.selectedRowDataMaps();
                                            if (selectedDatas.length == 0) {
                                                return;
                                            }
                                            var curDataMap = selectedDatas[0];
                                            var ret = GUI.showForm({
                                                title: self.ttr('Edit'),
                                                self: self,
                                                use_core_engine: true,
                                                items: uiItems,
                                                size: '500x400',
                                                buttons: [
                                                    self.ttr('Add') + ':Ok:Ok:Primary',
                                                    self.ttr('Cancel') + ':Cancel:Cancel:Error'
                                                ],
                                                values: curDataMap,
                                                include_hidden_items: true
                                            });
                                            if (_.isEmpty(ret)) {
                                                return;
                                            }
                                            if (curDataMap["CRUD"] != "create") {
                                                ret["CRUD"] = "update";
                                            }
                                            var mThis = this;
                                            this.getObject('plan_detail').setRowDataByPrimaryKey(curDataMap["id"], ret);
                                        }
                                        catch (e) {
                                            TMessageBox.error(this, '', e);
                                            print(e)
                                        }
                                    }
                                },
                                {
                                    name: 'copy_btn',
                                    type: 'Action',
                                    property: {
                                        text: self.ttr('Copy'),
                                        icon: 'copy',
                                        shortcut: '',
                                        tooltip: '',
                                        style: 'size=small  button_style=icon'
                                    },
                                    callback: function (obj, checked, self) {
                                        var plan_detail = this.getObject("plan_detail");
                                        var selectedDatas = plan_detail.selectedRowDataMaps();
                                        if (selectedDatas.length == 0) {
                                            return;
                                        }
                                        var curDataMap = selectedDatas[0];
                                        try {
                                            var ret = GUI.showForm({
                                                title: self.ttr('Copy'),
                                                self: self,
                                                use_core_engine: true,
                                                items: uiItems,
                                                size: '500x400',
                                                buttons: [
                                                    self.ttr('Add') + ':Ok:Ok:Primary',
                                                    self.ttr('Cancel') + ':Cancel:Cancel:Error'
                                                ],
                                                values: curDataMap,
                                                include_hidden_items: true
                                            });
                                            if (_.isEmpty(ret)) {
                                                return;
                                            }
                                            ret["id"] = APP.getNow();
                                            ret["CRUD"] = "create";
                                            this.getObject('plan_detail').appendRow(ret);
                                        }
                                        catch (e) {
                                            TMessageBox.error(this, '', e);
                                            print(e)
                                        }
                                    }
                                },
                                {
                                    name: 'remove_btn',
                                    type: 'Action',
                                    property: {
                                        text: self.ttr('Remove'),
                                        icon: 'minus',
                                        shortcut: '',
                                        tooltip: '',
                                        style: 'size=small  button_style=icon'
                                    },
                                    callback: function (obj, checked, self) {
                                        if ('ok' != TMessageBox.warning(self, self.ttr('Are you sure to remove selected items?'), '', self.ttr('Delete item'), [self.ttr('Delete') + ':ok:ok:warn', self.ttr('Cancel') + ':cancel:cancel:primary'])) {
                                            return;
                                        }
                                        var plan_detail = this.getObject("plan_detail");
                                        plan_detail.removeSelectedRows();
                                    }
                                }
                            ]
                        },
                        {
                            name: "plan_detail",
                            type: "TableView",
                            initCallback: function (obj, self) {
                                obj.setHeaderItem([
                                    {
                                    },
                                    {
                                        "name": "item",
                                        "display": self.ttr("Maintance Item"),
                                        "displayRole": "$item"
                                    },
                                    {
                                        "name": "method",
                                        "display": self.ttr("Maintance Method"),
                                        "displayRole": "$method"
                                    },
                                    {
                                        "name": "spec_value",
                                        "display": self.ttr("Spec Value"),
                                        "displayRole": "$spec_value"
                                    },
                                    {
                                        "name": "max_value",
                                        "display": self.ttr("Max Value"),
                                        "displayRole": "$max_value"
                                    },
                                    {
                                        "name": "min_value",
                                        "display": self.ttr("Min Value"),
                                        "displayRole": "$min_value"
                                    },
                                    {
                                        "name": 'auto_judge_policy',
                                        "display": self.ttr("Auto Judge Policy"),
                                        "displayRole": "$auto_judge_policy",
                                        "format": "enum(tpm-machine-maintance-plan-auto-judge-policy)"
                                    }
                                ]);
                                obj.setDataKeyList(["id", "item", "method", "spec_value", "max_value", "min_value", "auto_judge_policy", "CRUD"]);
                                obj.setPrimaryKey("id");
                            },
                            getter: function (obj, self) {
                                return obj.allDataMap();
                            },
                            setter: function (obj, value, self) {
                                if (value == undefined) {
                                    value = [];
                                }
                                return obj.loadData(value);
                            }
                        }
                    ]
                }
            ]
        }
    ]
}